"======================================================================
|
|   A stream wrapper with unlimited push back capabilites
|
|   $Revision: 1.4 $
|   $Date: 1995/06/06 14:54:50 $
|   $Author: sbb $
|
 ======================================================================"


"======================================================================
|
| Copyright (C) 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"


"
|     Change Log
| ============================================================================
| Author       Date       Change 
|
"

ReadStream subclass: #PushBackStream
	   instanceVariableNames: 'queue stream recording'
	   classVariableNames: ''
	   poolDictionaries: ''
	   category: nil
!

PushBackStream comment:
'LIFO pushback capability on top of ReadStreams'
!


!PushBackStream class methodsFor: 'instance creation'!

on: aStream
    ^super new init: aStream
! !


!PushBackStream methodsFor: 'accessing' !

next
    | char |
    queue size > 0 
	ifTrue: [ ^queue removeFirst ].
    char _ stream next.
    recording addLast: char.
    ^char
!

nextBypass
    "hack!!"
    ^self next
!

peek
    queue size > 0
	ifTrue: [ ^queue at: 1 ].
    
    ^stream peek
!

atEnd
    ^(queue size == 0) and: [ (stream atEnd) ]
!

atRealEnd
    ^self atEnd
!

putBack: anElement
    queue addFirst: anElement
!

close
    stream close
!

recording
    ^recording
!

resetRecording
    recording _ OrderedCollection new: 0.
! !






!PushBackStream methodsFor: 'private'!

init: aStream
    stream _ aStream.
    queue _ OrderedCollection new.
    self resetRecording.
! !
	
