"======================================================================
|
|   Smalltalk in Smalltalk compiler constant definitions
|
|   $Revision: 1.1 $
|   $Date: 1995/09/17 07:18:21 $
|   $Author: sbb $
|
 ======================================================================"


"======================================================================
|
| Copyright (C) 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"


"
|     Change Log
| ============================================================================
| Author       Date       Change 
| sbb	      3 Sep 95	  created.
|
"

Smalltalk at: #ByteCodeNames put: 
#(
    ( PushReceiverVariable	0)
    ( PushTemporaryVariable	16 )
    ( PushLitConstant		32 )
    ( PushLitVariable		64 )
    ( PopReceiverVariable	96 )
    ( PopTemporaryVariable	104 )
    ( PushSpecial		112 )
    ( ReturnIndexed		120 )
    ( ReturnMethodStackTop	124 )
    ( ReturnBlockStackTop	125 )
    ( PushIndexed		128 )
    ( StoreIndexed		129 )
    ( PopStoreIndexed		130 )
    ( SendSelector1ExtByte	131 )
    ( SendSelector2ExtByte	132 )
    ( SendSuper1ExtByte		133 )
    ( SendSuper2ExtByte		134 )
    ( PopStackTop		135 )
    ( DupStackTop		136 )
    ( PushActiveContext		137 )
    ( JumpShort			144 )
    ( PopJumpFalseShort		152 )
    ( JumpLong			160 )
    ( PopJumpTrue		168 )
    ( PopJumpFalse		172 )
    ( PlusSpecial		176 )
    ( MinusSpecial		177 )
    ( LessThanSpecial		178 )
    ( GreaterThanSpecial	179 )
    ( LessEqualSpecial		180 )
    ( GreaterEqualSpecial	181 )
    ( EqualSpecial		182 )
    ( NotEqualSpecial		183 )
    ( TimesSpecial		184 )
    ( DivideSpecial		185 )
    ( RemainderSpecial		186 )
    ( BitShiftColonSpecial	188 )
    ( IntegerDivideSpecial	189 )
    ( BitAndColonSpecial	190 )
    ( BitOrColonSpecial		191 )
    ( AtColonSpecial		192 )
    ( AtColonPutColonSpecial	193 )
    ( SizeSpecial		194 )
    ( NextSpecial		195 )
    ( NextPutColonSpecial	196 )
    ( AtEndSpecial		197 )
    ( SameObjectSpecial		198 )
    ( ClassSpecial		199 )
    ( BlockCopyColonSpecial	200 )
    ( ValueSpecial		201 )
    ( ValueColonSpecial		202 )
    ( DoColonSpecial		203 )
    ( NewSpecial		204 )
    ( NewColonSpecial		205 )
    ( SendSelectorNoArg		208 )
    ( SendSelector1Arg		224 )
    ( SendSelector2Arg		240 )
)!


| dict |
    dict _ Dictionary new: ByteCodeNames size * 2 "allow hashing to work".
    ByteCodeNames do: 
	[ :defn | dict at: (defn at: 1) put: (defn at: 2) ].
    ByteCodeNames _ dict.
!

Smalltalk at: #StorageLocations put: Dictionary new: 4.

StorageLocations 
    at: #ReceiverLocation        put: (0 bitShift: 6);
    at: #TemporaryLocation       put: (1 bitShift: 6);
    at: #LiteralConstantLocation put: (2 bitShift: 6);
    at: #LiteralVariableLocation put: (3 bitShift: 6)
!

Smalltalk at: #SpecialIndices put: 
#( ReceiverIndex
       TrueIndex
       FalseIndex
       NilIndex
       LiteralMinusOneIndex
       LiteralZeroIndex
       LiteralOneIdex
       LiteralTwoIndex
)!

| dict index |
    dict _ Dictionary new.
    index _ 0.
    SpecialIndices do: 
	[ :specialName | dict at: specialName put: index.
			 index _ index + 1 ].
    SpecialIndices _ dict.
!    
	   
       
