"======================================================================
|
|   Smalltalk in Smalltalk compiler symbol table
|
|   $Revision: 1.1 $
|   $Date: 1995/09/17 07:18:41 $
|   $Author: sbb $
|
 ======================================================================"


"======================================================================
|
| Copyright (C) 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"


"
|     Change Log
| ============================================================================
| Author       Date       Change 
| sbb	      3 Sep 95	  created.
|
"

FileStream fileIn: 'STVarDefn.st'!

Compiler subclass: #STSymbolTable
       instanceVariableNames: 'variables argCount literals classVars pools'
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
! 

!STSymbolTable class methodsFor: 'instance creation'!

new
    ^super new init
! !



!STSymbolTable methodsFor: 'declaring'!

declareArgument: argName
    "!!! check for duplicates
     !!! check for too many args"
    variables addLast: argName.
    argCount _ argCount + 1.
!

declareTemporary: tempName
    variables addLast: argName
!

addLiteral: aLiteral
    "Answers the index of the given literal.  If the literal is already 
present in the literals, returns the index of that one."
    ^self notYetImplemented 
! !

!STSymbolTable methodsFor: 'accessing'!

lookupName: aName
    "Answers a value for the name"
    ^self notYetImplemented 
! !



!STSymbolTable methodsFor: 'private'!

init
    variables _ OrderedCollection new: 0.
    literals _ OrderedCollection new: 0.
    argCount _ 0.
! !
