FileStream fileIn: 'File.st'!

File subclass: #Directory
       instanceVariableNames: ''
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
!    

CStruct newStruct: #DirentStruct 
	declaration: #((inode long)
			   (offset uLong)
			   (recLen uShort)
			   (name (array char 256))
			   )
!


!DirentStruct methodsFor: 'accessing'!

nameString
    | len str |
    len _ self recLen value. 
    str _ String new: len.
    1 to: len do:
	[ :i | str at: i 
		   put: (self name at: i - 1) ].
    ^str
! !



Behavior defineCFunc: 'opendir'
	 withSelectorArgs: 'openDir: dirName'
	 forClass: Directory
	 returning: #cObject
	 args: #(string)
!

Behavior defineCFunc: 'closedir'
	 withSelectorArgs: 'closeDir: dirObject'
	 forClass: Directory
	 returning: #int
	 args: #(cObject)
!

Behavior defineCFunc: 'readdir'
	 withSelectorArgs: 'readDir: dirObject'
	 forClass: Directory
	 returning: (CType baseType: DirentStruct)
	 args: #(cObject)
!

Behavior defineCFunc: 'rewinddir'
	 withSelectorArgs: 'rewindDir: dirObject'
	 forClass: Directory
	 returning: #void
	 args: #(cObject)
!

Behavior defineCFunc: 'seekdir'
	 withSelectorArgs: 'seekDir: dirObject offset: offset'
	 forClass: Directory
	 returning: #void
	 args: #(cObject long)
!



Behavior defineCFunc: 'telldir'
	 withSelectorArgs: 'tellDir: dirObject'
	 forClass: Directory
	 returning: #long
	 args: #(cObject)
!



!Directory class methodsFor: 'instance creation'!

name: aString
    ^self new init: aString
! !

!Directory methodsFor: 'accessing'!

do: aBlock
    | dir entry |
    dir _ self openDir: name.
    [ entry _ self readDir: dir.
      entry notNil ] whileTrue:
	  [ aBlock value: entry ].
    self closeDir: dir.
! !

!Directory methodsFor: 'private'!

init: aString
    name _ aString
! !


"
| d str len |
     d _ Directory name: '..'.
     d do: [ :dirent |
             len _ dirent recLen value. 
             str _ String new: len.
              1 to: len do:
                 [ :i | str at: i 
                            put: (dirent name at: i - 1) ].
             str printNl.
            ].
!

| d file |
     d _ Directory name: '..'.
     d do: [ :dirent | file _ File name: '../', dirent nameString.
                       stdout nextPutAll: file name ;
                            nextPutAll: ' size: ';
                            print: file stat stSize value;
                            nl.
	            
            ].
!
     
"




