"======================================================================
|
|   Testing a definition of 'eval'
|
|   $Revision: 1.4 $
|   $Date: 1995/06/06 14:54:50 $
|   $Author: sbb $
|
 ======================================================================"


"======================================================================
|
| Copyright (C) 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"


"
|     Change Log
| ============================================================================
| Author       Date       Change 
|
"

!Behavior methodsFor: 'testing'!

oldEval: aString
    self compileString: 'lastEvalExpression
    ^[ ', aString, '] value'.
    ^self lastEvalExpression
!

eval: aString
    self eval: aString
	 ifError: [ :file 
		    :line 
		    :error | file notNil
			ifTrue: [ stderr nextPut: $";
				      nextPutAll: file;
				      nextPutAll: '", ' ].
		    stderr nextPutAll: 'line ';
			print: line; 
			nextPutAll: ': ';
			nextPutAll: error; nl.
		    ^nil
			].
    ^self lastEvalExpression
!

eval: aString ifError: aBlock
    | str |
    str _ 'lastEvalExpression
    ^[ ', aString, '] value'.
    self compileString: str 
	 ifError: [ :file :line :error | ^aBlock value: file
						 value: line - 1
						 value: error ].
    ^self lastEvalExpression
! !

(Object eval: '3 + 4') printNl!

(Object eval: '3 + 4 



+.


+') printNl!
(Object eval: '3 + 4 +' 
	ifError: [ :a :b :c | ^'oops' printNl ]) printNl!

