'Filed out from Smalltalk version 1.2.alpha3 on 27-Jul-95  7:46:20 GMT'!

STObject subclass: #ClassBrowserController
    instanceVariableNames: 'scrolledText classBrowser splitView box window winDelegate classBrowserDelegate buttonMatrix classEditor '
    classVariableNames: 'isa '
    poolDictionaries: ''
    category: nil
!

!ClassBrowserController methodsFor: 'Actions'!

createClass
	| cell class |
	cell _ classBrowser selectedCell.
	class _ Smalltalk at: (cell stringValue asSymbol).

	classEditor isNil
		ifTrue: [ classEditor _ ClassEditor alloc init ].
	classEditor createSubclassOf: class.
!

editClass
	| cell class |
	cell _ classBrowser selectedCell.
	class _ Smalltalk at: (cell stringValue asSymbol).

	classEditor isNil
		ifTrue: [ classEditor _ ClassEditor alloc init ].
	classEditor editClass: class.
!

fileOutClass
	| cell category savePanel value file class rect filename dir |
	cell _ classBrowser selectedCell.
	class _ Smalltalk at: (cell stringValue asSymbol).
	
	cell notNil
		ifTrue: [
			rect _ Rect alloc initFromX: 200.0 y: 200.0 width: 500.0 height: 400.0.
			savePanel _ SavePanel newContent: (rect asCPointer) 
							style: 6 
							backing: 2 
							buttonMask: (4 bitOr: 1) 
							defer: YES.
			savePanel setRequiredFileType: 'st'.
			savePanel setTitle: 'Filing Out'.
			filename _ class name, '.st'.
			value _ savePanel runModalForDirectory: './' file: filename. 
			
			value == 1
				ifTrue: [
					filename _ savePanel filename.
					dir _ savePanel directory.
					
					" need to check if the file exists, if it does we
					  need to rename it filename~ and then file out
					  the selected class "
					  
					file _ FileStream open: filename mode: 'w'.
					file notNil
						ifTrue: [ class newFileOutOn: file. file close ] 
						ifFalse: [ self error: 'Couldn''t open file', filename ]. ]. ].
!

action2: sender
	" Popup a window for user to enter values for a new class"
	| matrix tag |
	matrix _ Matrix newFromId: sender.
	tag _ matrix selectedCell tag.
	tag == 0
		ifTrue: [ self createClass. ].
	tag == 1
		ifTrue: [ self editClass. ].
	tag == 2
		ifTrue: [ self fileOutClass. ].
!

action1: sender
	| cell selectedClass stream class text |
	
	text _ scrolledText text.
	cell _ classBrowser selectedCell.
	selectedClass _ Smalltalk at: (cell stringValue asSymbol).

	stream _ WriteStream on: (String new: 20).
	
    stream nl ; nextPutAll: '    instanceVariableNames: '.
	selectedClass instVarNames do: [ :name | stream nextPutAll: name; space. ].
    stream nl ; nextPutAll: '    classVariableNames: '.
    selectedClass classVarNames do: [ :name | stream nextPutAll: name; space. ].
    stream nl ; nextPutAll: '    poolDictionaries: '.
    stream nl ; nextPutAll: '    category: '.
    stream print: selectedClass category ; nl ; nl.
	
	selectedClass comment isNil
		ifTrue: [ stream nextPutAll: 'Please, no comment' ; nl. ]
		ifFalse: [ stream nextPutAll: selectedClass comment ; nl. ].

	text setText: stream contents.
	text sizeToFit.
	text scrollSelToVisible.
	scrolledText display.
!

doubleAction1: sender
	| cell class mBrowser |
	cell _ classBrowser selectedCell.
	class _ Smalltalk at: (cell stringValue asSymbol).
	mBrowser _ MethodBrowserController alloc initWithClass: class.
	(mBrowser window) makeKeyAndOrderFront: nil.
!!

!ClassBrowserController methodsFor: 'Creating The Interface'!

initClassBrowser: aRect
	| bounds prototype |
	
	bounds _ Rect alloc initFromRect: (aRect asCPointer).
	bounds setX: 0.0 ; setY: 68.0 ; setHeight: (((aRect height) / 2.0) - 30.0).
	
	prototype _ NXBrowserCell alloc initTextCell: 'Browser'.
	prototype setFont: ((Font newFont: 'Helvetica' size: 12.0) id).
	
	classBrowser _ NXBrowser alloc initFrame: (bounds asCPointer).
	classBrowser setAutosizing: (2 bitOr: 16).
	classBrowserDelegate _ ClassBrowserDelegate alloc init.
	classBrowser setCellPrototype: prototype id.
	classBrowser setDelegate: (classBrowserDelegate id).
	classBrowser setTarget: (self id).
	classBrowser setAction: (OCInterface getUid: 'action1:').
	classBrowser setDoubleAction: (OCInterface getUid: 'doubleAction1:').
	classBrowser setEmptySelectionEnabled: YES.
	classBrowser setHorizontalScrollButtonsEnabled: NO.
	classBrowser setHorizontalScrollerEnabled: YES.
	classBrowser setMaxVisibleColumns: 3.
	classBrowser loadColumnZero.
!

initMainWindow: aRect
	| red |
	window _ Window alloc initContent: (aRect asCPointer)
				style: 6
				backing: 2
				buttonMask: 4
				defer: YES.
	window setTitle: 'Class Browser'.
	
	"
	red _ Color alloc init.
	red setRedComponent: 0.8.
	red setGreenComponent: 0.1.
	red setBlueComponent: 0.1.
	window backgroundColor: red id.
	"
	
    winDelegate _ FreeOwnerWindowDelegate alloc init.
	winDelegate owner: self.
	window setDelegate: winDelegate id.

	window makeKeyAndOrderFront: (window id).		
!

initSplitView: aRect
	| bounds contentView size |
	bounds _ Rect alloc initFromRect: (aRect asCPointer).	
	bounds setX: 0.0 ; setY: 0.0.
	
	box _ Box alloc initFrame: (bounds asCPointer).
	box notifyAncestorWhenFrameChanged: YES.
	box setAutoresizeSubviews: YES.
	box setAutosizing: (2 bitOr:8; bitOr: 16).
	box setTitlePosition: 0.						" 0 = No Title "
	box setBorderType: 0.							" 0 = No Border "
	
	splitView _ NXSplitView alloc initFrame: (bounds asCPointer).
	splitView notifyAncestorWhenFrameChanged: YES.
	splitView setAutoresizeSubviews: YES.
	splitView setAutosizing: (2 bitOr:8; bitOr: 16).
	
	box setContentView: (splitView id).
!

initText: aRect
	| bounds font tan |

	bounds _ Rect alloc initFromRect: (aRect asCPointer).
	bounds setHeight: (((aRect height) / 2.0) - 30.0).

	scrolledText _ TextScrollView alloc initFrame: bounds.
	font _ Font newFont: 'Ohlfs' size: 10.0.
	scrolledText text setFont: font id.

	tan _ Color alloc init.
	tan setRedComponent: (153.0 / 255.0).
	tan setGreenComponent: (102.0 / 255.0).
	tan setBlueComponent: (85.0 / 255.0).
	scrolledText setBackgroundColor: tan.
!

compose
	| contentView |
	" Arranges everything on screen so that it looks nice "
	
	contentView _ window contentView.
	contentView notifyAncestorWhenFrameChanged: YES.
	contentView setAutoresizeSubviews: YES.

	splitView addSubview: classBrowser id.
	splitView addSubview: buttonMatrix id.
	splitView addSubview: scrolledText id.

	contentView addSubview: box id.
	contentView display.
!

initButtonMatrix: aRect
	| bounds size |
	
	bounds _ Rect alloc initFromRect: (aRect asCPointer).
	size _ Size alloc init.
	bounds setX: 0.0 ; setY: 0.0 ; setHeight: 60.0.
	
	buttonMatrix _ Matrix alloc initFrame: (bounds asCPointer)
							mode: 0							"NX_LISTMODE"
							cellClass: (ButtonCell isa)
							numRows: 1
							numCols: 6.

	buttonMatrix setAutosizeCells: YES.
	buttonMatrix setIntercell: (size asCPointer).
	
	buttonMatrix setTitle: 'Subclass...' at: 0 anArg: 0.
	buttonMatrix setTitle: 'Edit...' at: 0 anArg: 1.
	buttonMatrix setTitle: 'File Out...' at: 0 anArg: 2.
	buttonMatrix setTitle: 'File In...' at: 0 anArg: 3.
	buttonMatrix setTitle: 'Snapshot...' at: 0 anArg: 4.
	buttonMatrix setTitle: 'Find...' at: 0 anArg: 5.
	
	buttonMatrix setIcon: 'browser/AddClass.tiff' at: 0 anArg: 0.
	buttonMatrix setIcon: 'browser/EditClass.tiff' at: 0 anArg: 1.
	buttonMatrix setIcon: 'browser/FileOut.tiff' at: 0 anArg: 2.
	buttonMatrix setIcon: 'browser/FileIn.tiff' at: 0 anArg: 3.
	buttonMatrix setIcon: 'browser/Snapshot.tiff' at: 0 anArg: 4.
	buttonMatrix setIcon: 'browser/Find.tiff' at: 0 anArg: 5.
	
	buttonMatrix setTag: 0 at: 0 anArg: 0.
	buttonMatrix setTag: 1 at: 0 anArg: 1.
	buttonMatrix setTag: 2 at: 0 anArg: 2.
	buttonMatrix setTag: 3 at: 0 anArg: 3.
	buttonMatrix setTag: 4 at: 0 anArg: 4.
	buttonMatrix setTag: 5 at: 0 anArg: 5.
	
	buttonMatrix setAction: (OCInterface getUid: 'action2:').
	buttonMatrix setTarget: self id.
!!

!ClassBrowserController methodsFor: 'Freeing'!

free
	" Since I don't know the mechanism by which smalltalk free
	  objects I will free stuff explicitly whenever certain
	  windows are closed. "

	'Freeing a ClassBrowserController' printNl.

	scrolledText free.
	classBrowser free.
	buttonMatrix free.
	splitView free.
	box free.
	classBrowserDelegate free.
	
	super free.
!!

!ClassBrowserController methodsFor: 'Initialization'!

init
	| rect |
	super init.
	rect _ Rect alloc initFromX: 400.0 y: 600.0 width: 500.0 height: 400.0.
	self initMainWindow: rect.
	self initClassBrowser: rect.
	self initText: rect.
	self initButtonMatrix: rect.
	self initSplitView: rect.
	self compose.
!!

