"
| ============================================================================
| Below is the ClassBrowserDelegate class code
| ============================================================================
"


STNormalBrowserDelegate subclass: #ClassBrowserDelegate
		 instanceVariableNames: ''
		 classVariableNames: ''
		 poolDictionaries: ''
		 category: nil
!

ClassBrowserDelegate comment: 'Delegate to a NXBrowser that provides the browser
will data to browse a class heirarchy'!

!ClassBrowserDelegate methodsFor: 'Browsing'!

browser: arg0 titleOfColumn: arg1 
	^'Class Heirarchy'
!

browser: arg0 fillMatrix: arg1 inColumn: arg2
	| sender matrix column cell selString selClass classes i sorted |
	matrix _ Matrix newWithId: arg1.
	sender _ NXBrowser newWithId: arg0.
	column _ arg2.
	
	(column == 0)
		ifTrue: [
			matrix addRow.
			cell _ matrix cellAt: 0 anArg: 0.
			cell setStringValue: 'Object'.
			cell setLoaded: YES.
			cell setLeaf: NO. 
			^1.]
		ifFalse: [
			cell _ sender selectedCell.
			selClass _ Smalltalk at: ((cell stringValue) asSymbol).
			classes _ selClass subclasses.  
			sorted _ Set new.
			classes do: [ :class | sorted add: (class name) ].
			
			i _ 0.			
			sorted asSortedCollection
				do: [ :element | 
					matrix addRow.
					cell _ matrix cellAt: i anArg: 0.
					cell setStringValue: element.
					
					((Smalltalk at: (cell stringValue asSymbol)) isKindOf: (OCObject class))
						ifTrue: [ cell setFont: ((Font newFont: 'Helvetica-Oblique' size: 12.0) id). ].
					((Smalltalk at: (cell stringValue asSymbol)) isKindOf: (STObject class))
						ifTrue: [ cell setFont: ((Font newFont: 'Helvetica-BoldOblique' size: 12.0) id). ].

					cell setLoaded: YES.
						
					((Smalltalk at: (cell stringValue asSymbol)) subclasses size) > 0 
						ifTrue: [ cell setLeaf: NO ]
						ifFalse: [ cell setLeaf: YES ].
 					i _ i + 1. ].				
			^i ].
	^0			
!

browser: arg0 getNumRowsInColumn: arg1
	^0
!!
