'Filed out from Smalltalk version 1.2.alpha3 on 27-Jul-95  6:13:57 GMT'!

STObject subclass: #ErrorInspector
    instanceVariableNames: 'window winDelegate splitView box msgBrowser msgBrowserDelegate msgST contexts ivarSSV ivarBrowser ivarBrowserDelegate ivarST ivars stackSSV stackBrowser stackBrowserDelegate stackST stackVars '
    classVariableNames: 'isa '
    poolDictionaries: ''
    category: 'nil'
!
!ErrorInspector methodsFor: 'Action'!

displaySelectorAtContext: index
	| receiver selector context |

	context _ contexts at: index.
	receiver _ context receiver.
	selector _ context selector.
	
	selector isNil
		ifTrue: [ msgST text setText: 'nil selector'. ^self ].
	
	receiver isNil
		ifTrue: [ msgST text setText: 'nil receiver'. ^self ].
	
	msgST text setText: ((context methodClass) sourceCodeAt: selector).

!

doubleAction2: sender
	| index matrix col stackVar |
	col _ stackBrowser selectedColumn.
	matrix _ stackBrowser matrixInColumn: col.
	index _ matrix selectedRow.
	stackVar _ stackVars at: index + 1.
	stackVar notNil
		ifTrue: [ stackVar guiInspect ]	
		
!

displayStackValueAt: index
	| stackVar |
	stackVar _ stackVars at: index.
	stackVar notNil
		ifTrue: [ stackST text setText: stackVar printString ]	
		ifFalse: [ stackST text setText: 'nil value at ', index printString ]	
!

action2: sender
	| index matrix col |
	col _ stackBrowser selectedColumn.
	matrix _ stackBrowser matrixInColumn: col.
	index _ matrix selectedRow.
	index _ index + 1.
	self displayStackValueAt: index.
!

displayStackAtContext: index
    | context stackVarNames method totalVars |

	context _ contexts at: index.
	method _ context method.
	
	context isNil
		ifTrue: [ ^self ].
	method isNil
		ifTrue: [ ^self ].
		
    totalVars _ method numArgs + method numTemps.

    stackVarNames _ OrderedCollection new: totalVars + 1.
    stackVarNames add: #thisContext.

    1 to: totalVars do:
		[ :i | stackVarNames add: i printString ].
    
    stackVars _ OrderedCollection new: totalVars + 1.
    stackVars add: context.

    2 to: totalVars + 1 do:
		[ :i | stackVars add: (context at: i - 1) ].
	
	stackBrowserDelegate collection: stackVarNames.
	stackBrowser loadColumnZero.
!

action1: sender
	| index matrix col |
	col _ msgBrowser selectedColumn.
	matrix _ msgBrowser matrixInColumn: col.
	index _ matrix selectedRow.
	index _ index + 1.
	
	self displaySelectorAtContext: index.
	self displayStackAtContext: index.
!!

!ErrorInspector methodsFor: 'Browsing'!

browseError: message errors: errorCollection contexts: contextCollection
	| text stream |
	contexts _ contextCollection.
	msgBrowserDelegate collection: errorCollection.
	msgBrowser loadColumnZero.
	window setTitle: message.
	window makeKeyAndOrderFront: nil.
!!

!ErrorInspector methodsFor: 'Freeing'!

free
	" Since I don't know the mechanism by which smalltalk free
	  objects I will free stuff explicitly whenever certain
	  windows are closed. "
	  
	'Freeing an error inspector' printNl.

	" Note that you need to send subviews a free message
	  before sending there super view a free or things 
	  will get freed twice "
	  
	msgBrowser free.
	msgBrowserDelegate free.
	msgST free.

	stackBrowser free.
	stackBrowserDelegate free.
	stackST free.
	stackSSV free.

	splitView free.
	box free.
	super free.
!!

!ErrorInspector methodsFor: 'Initing'!

createBrowser: rect

	msgBrowser _ NXBrowser alloc initFrame: (rect asCPointer).
	msgBrowserDelegate _ CollectionBrowserDelegate alloc init.
	msgBrowserDelegate title: 'Stack Trace'.
	msgBrowser setDelegate: (msgBrowserDelegate id).
	msgBrowser setTarget: (self id).
	msgBrowser setAction: (OCInterface getUid: 'action1:').
	msgBrowser setEmptySelectionEnabled: NO.
	msgBrowser setHorizontalScrollButtonsEnabled: NO.
	msgBrowser setHorizontalScrollerEnabled: NO.
	msgBrowser setMaxVisibleColumns: 1.
	msgBrowser loadColumnZero.

	stackBrowser _ NXBrowser alloc init.
	stackBrowserDelegate _ CollectionBrowserDelegate alloc init.
	stackBrowserDelegate title: 'Method Context Var Inspector'.
	stackBrowser setDelegate: (stackBrowserDelegate id).
	stackBrowser setTarget: (self id).
	stackBrowser setAction: (OCInterface getUid: 'action2:').
	stackBrowser setDoubleAction: (OCInterface getUid: 'doubleAction2:').
	stackBrowser setEmptySelectionEnabled: NO.
	stackBrowser setHorizontalScrollButtonsEnabled: NO.
	stackBrowser setHorizontalScrollerEnabled: NO.
	stackBrowser setMaxVisibleColumns: 1.
	stackBrowser loadColumnZero.

!

createWindow: rect
	window _ Window alloc initContent: (rect asCPointer)
								style: 6
							  backing: 2
						   buttonMask: (4 bitOr: 1)
								defer: YES.
	window setTitle: 'Error Inspector '.

    winDelegate _ FreeOwnerWindowDelegate alloc init.
	winDelegate owner: self.
	window setDelegate: winDelegate id.
!

createSplitView: rect
	| bounds contentView size |
	bounds _ Rect alloc initFromRect: rect asCPointer.	
	bounds setX: 0.0 ; setY: 0.0.
	
	box _ Box alloc initFrame: (bounds asCPointer).
	box notifyAncestorWhenFrameChanged: YES.
	box setAutoresizeSubviews: YES.
	box setAutosizing: (2 bitOr:8; bitOr: 16).
	box setTitlePosition: 0.						" 0 = No Title "
	box setBorderType: 0.							" 0 = No Border "

	splitView _ NXSplitView alloc initFrame: (rect asCPointer).
	splitView notifyAncestorWhenFrameChanged: YES.
	splitView setAutoresizeSubviews: YES.
	splitView setAutosizing: (2 bitOr:8; bitOr: 16).

	box setContentView: (splitView id).

	stackSSV _ SideSplitView alloc initFrame: (rect asCPointer).
!

createScrolledText: rect
	| font  lightBlueColor lightBlueColor1 |

	lightBlueColor1 _ Color alloc init.
	lightBlueColor1 setRedComponent: (102.0 / 255.0 ).
	lightBlueColor1 setGreenComponent: (170.0 / 255.0 ).
	lightBlueColor1 setBlueComponent: (255.0 / 255.0 ).

	msgST _ TextScrollView alloc initFrame: rect.
	font _ Font newFont: 'Ohlfs' size: 10.0.
	msgST setBackgroundColor: lightBlueColor1.
	msgST text setMonoFont: YES.
	msgST text setFont: (font id).
	
	lightBlueColor _ Color alloc init.
	lightBlueColor setRedComponent: (68.0 / 255.0 ).
	lightBlueColor setGreenComponent: (85.0 / 255.0 ).
	lightBlueColor setBlueComponent: (255.0 / 255.0 ).
	stackST _ TextScrollView alloc initFrame: rect.
	stackST setBackgroundColor: lightBlueColor.
	stackST text setMonoFont: YES.
	stackST text setFont: (font id).
!

compose
	| contentView |
	" Arranges everything on screen so that it looks nice "
	
	contentView _ window contentView.
	contentView notifyAncestorWhenFrameChanged: YES.
	contentView setAutoresizeSubviews: YES.

	splitView addSubview: msgBrowser id.
	splitView addSubview: msgST id.
		
	stackSSV setRightView: stackST id.
	stackSSV setLeftView: stackBrowser id.

	splitView addSubview: stackSSV id.	

	contentView addSubview: box id.
!

init	
	| rect |
	rect _ Rect alloc initFromX: 600.0 y: 300.0 width: 400.0 height: 400.0.

	super init.
	self createWindow: rect.
	self createBrowser: rect.
	self createScrolledText: rect.
	self createSplitView: rect.
	self compose.
!!

