" 
	Replace a couple of Object built in methods with these
  	so that we can catch errors and display the 
"

(Object includesSelector: #originalDoesNotUnderstand: )
    ifFalse: [ Object addSelector: #originalDoesNotUnderstand: 
		      withMethod: (Object compiledMethodAt: #doesNotUnderstand:) ]!

(Object includesSelector: #originalError: )
    ifFalse: [ Object addSelector: #originalError: 
		      withMethod: (Object compiledMethodAt: #error:) ]!

!Object methodsFor: 'Visual Inspection'!

guiInspect
	ObjectInspector alloc init inspect: self.
!!

!Object methodsFor: 'overriding'!

error: message
    | context names contexts name nameStr |

    HandleErrorsWithGui
		ifFalse: [ ^self originalError: message ].
	
    names _ OrderedCollection new.
    contexts _ OrderedCollection new.
    
    context _ thisContext.

    HandleErrorsWithGui _ false.
    [ context notNil ] 
		whileTrue: [ 
			nameStr _ WriteStream on: (String new: 5).
			nameStr nextPutAll: context realReceiverName;
	      			nextPutAll: '>>#'; 
	      			nextPutAll: context selector printString.
	  		name _ nameStr contents.
	  		names add: name.
	  		contexts add: context.
	  		context _ context parentContext ].

	"ErrorInspector new: message errors: names contexts: contexts."
	ErrorInspector alloc init browseError: message 
							errors: names 
							contexts: contexts.
    HandleErrorsWithGui _ true.
!

doesNotUnderstand: message
	HandleErrorsWithGui
    	ifTrue: [ self error: self printString, ' Did not understand ', message selector. ]
		ifFalse: [ self originalDoesNotUnderstand: message ]
!!

!BlockContext methodsFor: 'debugging'!

callers
    self inspect.
    caller notNil
	ifTrue: [ caller callers ]
!

parentContext
    ^caller
!

selector
    ^selector
!

receiverName
    ^'[] in ', home class name
!

realReceiverName
    "Temp hack"
    ^'[] in ', home class name

! !

!MethodContext methodsFor: 'debugging'!

callers
    self inspect.
    sender notNil 
		ifTrue: [ sender callers ]
!

parentContext
    ^sender
!

receiverName
    | name |
    name _ receiver class name.
    name isNil ifTrue: [ name _ receiver name ].
    ^name
!

methodClass
	^methodClass
!

realReceiverName
    | name receiverClass methodClassName |
    
    receiverClass _ receiver class.
    receiverClass ~~ methodClass
	ifTrue: [ name _ self receiverName.
		  methodClassName _ methodClass name.
		  ^name , '(', methodClassName, ')'  ]
	ifFalse: [ ^self receiverName ].

!!
