"======================================================================
|
|   X Cursor classes
|
|   $Revision: 1.3 $
|   $Date: 1995/06/06 14:56:15 $
|   $Author: sbb $
|
 ======================================================================"

"======================================================================
|
| Copyright (C) 1990, 1991, 1992, 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"

"
|     Change Log
| ============================================================================
| Author       Date       Change 
| sbb	     26 Oct 90	  Created.
|
"



XServerObject subclass: #Cursor
	  instanceVariableNames: ''
	  classVariableNames: ''
	  poolDictionaries: ''
	  category: 'X Objects'
!

!Cursor class methodsFor: 'X object instance creation'!

createCursor: source mask: mask foreRed: foreRed foreGreen: foreGreen
    foreBlue: foreBlue backRed: backRed backGreen: backGreen backBlue: backBlue
    x: x y: y onServer: server
    | id req |
    id _ server nextId.
    req _ XRequest fixedCommand: 93.
    req ulong: id; ulong: source id;
	ulong: (XProtocol maybeMapId: mask into: #(None));
	uword: foreRed; uword: foreGreen; uword: foreBlue;
	uword: backRed; uword: backGreen; uword: backBlue;
	uword: x; uword: y.
    req queueOn: server.
    ^self new init: id onServer: server
!


createGlyphCursor: sourceFont maskFont: maskFont sourceChar: sourceChar
    maskChar: maskChar foreRed: foreRed foreGreen: foreGreen
    foreBlue: foreBlue backRed: backRed backGreen: backGreen backBlue: backBlue
    onServer: server
    | id req |
    id _ server nextId.
    req _ XRequest fixedCommand: 94.
    req ulong: id; ulong: sourceFont id;
	ulong: (XProtocol maybeMapId: maskFont into: #(None));
	uword: sourceChar; uword: maskChar;
	uword: foreRed; uword: foreGreen; uword: foreBlue;
	uword: backRed; uword: backGreen; uword: backBlue.
    req queueOn: server.
    ^self new init: id onServer: server
! !



!Cursor methodsFor: 'X protocol requests'!

freeCursor
    | req |
    req _ XRequest fixedCommand: 95.
    req ulong: id.
    req queueOn: server
!

recolorCursor: foreRed foreGreen: foreGreen foreBlue: foreBlue
    backRed: backRed backGreen: backGreen backBlue: backBlue
    | req |
    req _ XRequest fixedCommand: 96.
    req ulong: id;
	uword: foreRed; uword: foreGreen; uword: foreBlue;
	uword: backRed; uword: backGreen; uword: backBlue.
    req queueOn: server
! !



LoadStatus _ 'Cursor'!
