"======================================================================
|
|   Experimental STIX based input event handler
|
|   $Revision: 1.3 $
|   $Date: 1995/06/06 14:56:15 $
|   $Author: sbb $
|
 ======================================================================"

 "======================================================================
|
| Copyright (C) 1990, 1991, 1992, 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"

"
|     Change Log
| ============================================================================
| Author       Date       Change 
| sbb	     16 Feb 92	  created.
|
"

Smalltalk at: #EventHandlers put: Dictionary new!
Smalltalk at: #ExitHandlerLoop put: nil!
Smalltalk at: #AccessorMethods put: Dictionary new!

!Window methodsFor: 'event handling'!

registerFor: anEventClass when: conditionBlock do: handlerBlock
    | handlers |
    handlers _ EventHandlers at: anEventClass
				ifAbsent: [ EventHandlers at: anEventClass
							  put: OrderedCollection new.
					    EventHandlers at: anEventClass ].
    handlers add: conditionBlock -> handlerBlock
! !


!Server methodsFor: 'event dispatching'!

processEvents
    | e win handlers |
    ExitHandlerLoop _ false.
    [ ExitHandlerLoop ] whileFalse:
	[ e _ self nextEvent.
	  handlers _ EventHandlers at: e class
				   ifAbsent: 
				       [ ^self error: 'Could not find a handler for ',
					     e class printString ].
	  handlers do:
	      [ :handler | (handler key value: e)
			       ifTrue: [ handler value value: e ]
			       ]
	      ]
! !


