"======================================================================
|
|   X Font-like class
|
|   $Revision: 1.3 $
|   $Date: 1995/06/06 14:56:15 $
|   $Author: sbb $
|
 ======================================================================"

"======================================================================
|
| Copyright (C) 1990, 1991, 1992, 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"

"
|     Change Log
| ============================================================================
| Author       Date       Change 
| sbb	     21 Nov 90	  Created change log.
|
"
XServerObject subclass: #Fontable
	  instanceVariableNames: ''
	  classVariableNames: ''
	  poolDictionaries: ''
	  category: 'X Objects'
!

!Fontable methodsFor: 'X protocol requests'!

queryFont
    | minBounds maxBounds minCharOrByte2 maxCharOrByte2
      defaultChar numFontProps drawDirection minByte1 maxByte1 allCharsExist
      fontAscent fontDescent numCharInfos properties charInfos |
    self justId: 47.

    server getReply.

    minBounds _ server charInfo.
    server long.		"ignored"
    maxBounds _ server charInfo.
    server long.		"ignored"
    minCharOrByte2 _ server uword.
    maxCharOrByte2 _ server uword.
    defaultChar _ server uword.
    numFontProps _ server word.
    drawDirection _ XProtocol unmap: (server byte) 
			      into: #(LeftToRight RightToLeft).
    minByte1 _ server ubyte.
    maxByte1 _ server ubyte.
    allCharsExist _ server bool.
    fontAscent _ server word.
    fontDescent _ server word.
    numCharInfos _ server ulong.
    properties _ Array new: numFontProps.
    1 to: numFontProps do:
	[ :i | properties at: i put: (server fontProp) ].
    charInfos _ Array new: numCharInfos.
    1 to: numCharInfos do:
	[ :i | charInfos at: i put: (server charInfo) ].
    ^QueryFontReply minBounds: minBounds maxBounds: maxBounds 
		    minCharOrByte2: minCharOrByte2 
		    maxCharOrByte2: maxCharOrByte2
		    defaultChar: defaultChar drawDirection: drawDirection
		    minByte1: minByte1 maxByte1: maxByte1
		    allCharsExist: allCharsExist fontAscent: fontAscent
		    fontDescent: fontDescent properties: properties 
		    charInfos: charInfos
!



queryTextExtents: string
    | req drawDirection fontAscent fontDescent overallAscent overallDescent
      overallWidth overallLeft overallRight |
    req _ XRequest command: 48 
		   aux: (XProtocol mapBool: ((string size \\ 2) = 1)).
    req ulong: id; string16: string.
    req queueOn: server.

    drawDirection _ server getMappedReply: #(LeftToRight RightToLeft).
    fontAscent _ server word.
    fontDescent _ server word.
    overallAscent _ server word.
    overallDescent _ server word.
    overallWidth _ server long.
    overallLeft _ server long.
    overallRight _ server long.
    server long.		"unused"
    ^QueryTextExtentsReply drawDirection: drawDirection fontAscent: fontAscent
			   fontDescent: fontDescent 
			   overallAscent: overallAscent
			   overallDescent: overallDescent
			   overallWidth: overallWidth 
			   overallLeft: overallLeft overallRight: overallRight
! !

LoadStatus _ 'Fontable'!


FileStream fileIn: 'Font.st'!
FileStream fileIn: 'GC.st'!

