"======================================================================
|
|   Simple Lego like pieces manipulation
|
|   $Revision: 1.3 $
|   $Date: 1995/06/06 14:56:15 $
|   $Author: sbb $
|
 ======================================================================"

 "======================================================================
|
| Copyright (C) 1990, 1991, 1992, 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"

"
|     Change Log
| ============================================================================
| Author       Date       Change 
| sbb	     16 Feb 92	  created.
|
"

X subclass: #Lego
  instanceVariableNames: 'location width height color unitSize window cmap
			  colorPixelMap savedGC lastColor'
  classVariableNames: ''
  poolDictionaries: ''
  category: 'Fun hacking'
!

Lego comment: '###No comment yet'!

!Lego class methodsFor: 'instance creation'!

legoAt: aPoint width: w height: h color: aColorName on: aWindow
    ^self new initAt: aPoint width: w height: h color: aColorName
	      on: aWindow vscale: 6
! 

legoAt: aPoint width: w height: h color: aColorName on: aWindow vScale: vscale
    ^self new initAt: aPoint width: w height: h color: aColorName
	      on: aWindow vscale: vscale
! 

smallLegoAt: aPoint width: w height: h color: aColorName on: aWindow
    ^self new initAt: aPoint width: w height: h color: aColorName
	      on: aWindow vscale: 2
! !
	     
!Lego methodsFor: 'fun hacking'!

moveTo: aPoint
    self drawColor: 'black'.
    location _ aPoint.
    self draw
!


draw
    self drawColor: color
!

width
    ^width
!

size
    ^unitSize
!

drawColor: aColorName
   | realWidth realHeight gc scale x y rects bytes |

    scale _ self scale.

    realWidth _ width * 5 * scale.
    realHeight _ height * unitSize * scale.

    gc _ self gc: aColorName.
    y _ location y.
    
    rects _ Array new: width + 1.
    1 to: width do:
	[ :i | x _ location x + ((i - 1) * 5 * scale) + (1 * scale).
	       rects at: i 
		     put: ((x @ (y - scale)) extent: ((scale*3) @ scale)) ].
					 
    rects at: width + 1
	  put: (location extent: realWidth @ realHeight).

"    window server doTiming: true."
"    100 timesRepeat: ["
"    bytes _ Smalltalk byteCodeCounter."
"    (Time millisecondsToRun: ["
"    Smalltalk verboseTrace: true.
    Smalltalk executionTrace: true."
    window polyFillRectangle: gc
	   rectangles: rects. 
"    Smalltalk executionTrace: false.
    Smalltalk verboseTrace: false."
"    ]) printNl."
"    stdout nextPutAll: 'Bytes executed: ';
	print: Smalltalk byteCodeCounter - bytes;
	nl."
"    ]."
"    window server doTiming: nil."

    "cmap freeColors: (Array with: colorPixel) planeMask: 0"

! !




!Lego methodsFor: 'private'!

scale
    ^3
!

colorPixelFor: aColorName
    | colorPixel |
    ^colorPixelMap
	at: aColorName
	ifAbsent: 
	    [ colorPixel _ (cmap allocNamedColor: aColorName) pixel.
	      colorPixelMap at: aColorName put: colorPixel.
	      ^colorPixel ]
!

initAt: aPoint width: w height: h color: aColorName
    on: aWindow vscale: vScale
    | scale |
    scale _ self scale.
    location _ aPoint.
    width _ w.
    height _ h.
    color _ aColorName.
    unitSize _ vScale.
    window _ aWindow.
    cmap _ window getWindowAttributes colormap.
    colorPixelMap _ Dictionary new.
    self draw
!

gc: aColorName
    | colorPixel |
    (savedGC isNil or: [ aColorName ~= lastColor ])
	ifTrue: [ colorPixel _ self colorPixelFor: aColorName.
		  savedGC _ GC createGC: window onServer: window server
			       args: [ :r | r foreground: colorPixel ] ].
    lastColor _ aColorName.
    ^savedGC
! !
