"======================================================================
|
|   X Text item class definitions.
|
|   $Revision: 1.3 $
|   $Date: 1995/06/06 14:56:15 $
|   $Author: sbb $
|
 ======================================================================"

"======================================================================
|
| Copyright (C) 1990, 1991, 1992, 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"


"
|     Change Log
| ============================================================================
| Author       Date       Change 
| sbyrne     24 May 90	  created.
|
"

Object subclass: #TextItem
       instanceVariableNames: 'type delta string font'
       classVariableNames: ''
       poolDictionaries: ''
       category: 'X Hacking'
!

!TextItem class methodsFor: 'instance creation'!


onString: aString
    ^self new: aString delta: 0
!

new: aString delta: anInteger
    ^self new init: aString delta: anInteger
!!


!TextItem methodsFor: 'writing'!

emitTo: aPacket
    type 
	ifTrue:
	    [ aPacket byte: string size.
	      aPacket byte: delta.
	      aPacket bytes: string asByteArray ]
	ifFalse:
	    [ aPacket byte: 255.
	      aPacket byte: font / (256 * 256 * 256).
	      aPacket byte: font / (256 * 256) \\ 256.
	      aPacket byte: font / (256) \\ 256.
	      aPacket byte: font \\ 256 ]
!!

!TextItem methodsFor: 'private'!

init: aString delta: anInteger
    type _ true.
    string _ aString.
    delta _ anInteger
!!
