"======================================================================
|
|   X window manager interface definitions
|
|   $Revision: 1.3 $
|   $Date: 1995/06/06 14:56:15 $
|   $Author: sbb $
|
 ======================================================================"

"======================================================================
|
| Copyright (C) 1990, 1991, 1992, 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"

"
|     Change Log
| ============================================================================
| Author       Date       Change 
| sbb	     27 Nov 92	  
|
| sbb	     16 Feb 92	  created a while ago
|
"

X variableSubclass: #WM
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''
  category: '???'
!

WM comment:
'I represent the protocol which X window manager properties need to supply
in order to work properly.  Basically, my size operation returns my
instance size in bytes, and I supply a do: operation which iterates
through my indexable instance variables.'
!

!WM class methodsFor: 'instnace creation'!

new: num
    | vec |
    vec _ super new: num.
    1 to: num do:
	[ :i | vec at: i put: 0 ].
    ^vec
! !



!WM methodsFor: 'ICCCM protocol'!

size
    ^super size * 4		"want size in bytes"
!

do: aBlock
    1 to: super size do:
	[ :index | aBlock value: (self at: index) ]

! !



WM variableSubclass: #WMSizeHints
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''
  category: '???'
!


!WMSizeHints class methodsFor: 'instance creation'!

new
    ^super new: 18
!

new: num
    ^self shouldNotImplement
! !

!WMSizeHints methodsFor: 'setting things'!

flags: mask
    self at: 1 put: (XProtocol mask: mask using:
			 #(USPosition USSize PPosition PSize PMinSize
			       PMaxSize PResizeInc PAspect PBaseSize
			       PWinGravity))
!

"2 -- 5 are compatibility padding"

minWidth: anInteger
    self at: 6 put: anInteger
!

minHeight: anInteger
    self at: 7 put: anInteger
!

maxWidth: anInteger
    self at: 8 put: anInteger
!

maxHeight: anInteger
    self at: 9 put: anInteger
!

widthInc: anInteger
    self at: 10 put: anInteger
!
    
heightInc: anInteger
    self at: 11 put: anInteger
!
    
minAspect: xValue y: yValue
    self at: 12 put: xValue.
    self at: 13 put: yValue
!

maxAspect: xValue y: yValue
    self at: 14 put: xValue.
    self at: 15 put: yValue
!

baseWidth: anInteger
    self at: 16 put: anInteger
!

baseHeight: anInteger
    self at: 17 put: anInteger
!

winGravity: gravitySymbol
    self at: 18 put: (XProtocol map: gravitySymbol
				into: #(nil NorthWest North NorthEast
					    West Center East
					    SouthWest South SouthEast))
! !




WM variableSubclass: #WMHints
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''
  category: '???'
!


"Probably not running yet"

!WMHints class methodsFor: 'instance creation'!

new
    ^super new: 9.
!

new: num
    ^self shouldNotImplement
! !

!WMHints methodsFor: 'accessing'!

flags: mask
    self at: 1 put: (XProtocol  mask: mask 
				using: #(InputHint StateHint IconPixmapHint 
					     IconWindowHint 
					     IconPositionHint IconMaskHint 
					     WindowGroupHint))
!

input: aBool
    self at: 2 put: (XProtocol mapBool: aBool)
!

initialState: aSymbol
    self at: 3 
	 put: (XProtocol map: aSymbol 
			 into: #(WithdrawnState NormalState nil IconicState))
!

iconPixmap: pm
    self at: 4 put: pm id
!    

iconWindow: win
    self at: 5 put: win id
!

iconX: anInteger
    "should probably check to ensure that we have an integer"
    self at: 6 put: anInteger
!

iconY: anInteger
    "should probably check to ensure that we have an integer"
    self at: 7 put: anInteger
!

iconMask: pm
    self at: 8 put: pm id
!

windowGroup: winGroup
    self at: 9 put: winGroup id
! !




