"======================================================================
|
|   Draws an interesting design.
|
|   $Revision: 1.3 $
|   $Date: 1995/06/06 14:56:15 $
|   $Author: sbb $
|
 ======================================================================"


"======================================================================
|
| Copyright (C) 1990, 1991, 1992, 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"

"
|     Change Log
| ============================================================================
| Author       Date       Change 
"
Smalltalk at: #s put: nil!

!Window methodsFor: 'testing'!

doHierarchy: aBlock
    aBlock value: self.
    (self queryTree children) do:
	[ :ch | ch doHierarchy: aBlock ]
! !


| screen rootWin root gc propRepl w d cmap | 
    s notNil ifTrue:
	[ s close ].
    s _ Server connectToDisplay.
    root _ s root.
    screen _ root screens at: 1.
    rootWin _ screen window.

    w _ Window new init: 9437268 onServer: s.
    cmap _ w getWindowAttributes colormap.
    ((cmap queryColors: #(5)) colors at: 1) inspect

!

| screen rootWin root gc propRepl w d cmap pix b pts | 
    s notNil ifTrue:
	[ s close ].
    s _ Server connectToDisplay.
    root _ s root.
    screen _ root screens at: 1.
    rootWin _ screen window.

    w _ Window createWindow: rootWin class: #CopyFromParent
	       depth: 0
	       visual: #CopyFromParent x: 0 y: 0
	       width: 1152 height: 900 borderWidth: 0 onServer: s
	       attrs: [ :r | r eventMask: #(Exposure ButtonPress);
				 backgroundPixel: screen blackPixel;
				 overrideRedirect: true].

    w mapWindow.
    s nextEvent inspect.		"ignore expose event"

    cmap _ w getWindowAttributes colormap.
    pix _ (cmap allocColor: 39321
		green: 46003
		blue: 65535) pixel.
    
    b _ [ :delta | gc _ GC createGC: w onServer: s args: 
		       [ :r | r foreground: pix;
				  lineWidth: 16].
		   pts _ Array with: -1000@ -1000 with: 1000@1000.
		   1 to: pts size do:
		       [ :i | pts at: i
				  put: (pts at: i) + delta ].
		   w polyLine: gc coordinateMode: #Origin
		     points: pts.

		   gc changeGC: [ :r | r lineWidth: 8].
		   pts _ Array with: -1000@ -870 with: 1000@1130.
		   1 to: pts size do:
		       [ :i | pts at: i
				  put: (pts at: i) + delta ].

		   w polyLine: gc coordinateMode: #Origin
		     points: pts.
		   ].
    
    b value: 0@0.
    b value: 0@500.
    b value: 500@0.

!



| screen rootWin root gc propRepl w d wid | 
    s notNil ifTrue:
	[ s close ].
    s _ Server connectToDisplay.
    root _ s root.
    screen _ root screens at: 1.
    rootWin _ screen window.

    w _ Window new init: 9437268 onServer: s.
    wid _ 680.
"    d _ (w getImage: 0 y: 0 width: 680 height: 850
      planeMask: 16rFF
      format: #ZPixmap) data. "
    d _ (w getImage: 0 y: 1 width: 680 height: 1
	   planeMask: 16rFF
	   format: #ZPixmap) data.

    stdout 
	nextPutAll: '"Top row"'; nl;
	store: d; nl; nl.

    d _ (w getImage: 1 y: 0 width: 1 height: 850
	   planeMask: 16rFF
	   format: #ZPixmap) data.
    
    stdout 
	nextPutAll: '"Side row"'; nl;
	store: d; nl; nl.

    stdout store: d; nl; nl.

[
    1 to: 680 do: 
	[ :i | 
	       stdout print: (i - 1) * 32; space.
	       1 to: 32 do:
		   [ :j | (d at: ((i - 1) * 32) + j) print.
			  ].
	       stdout nl 
		   ]. 
] .

    [
    1 to: 850 do: 
	[ :i | 
	       d _ (w getImage: 0 y: i - 1 width: 680 height: 1
		      planeMask: 16rFF
		      format: #ZPixmap) data.
	       stdout print: i - 1; space.
	       
	       1 to: 32 do:
		   [ :j | (d at: j) print.
			  "(d at: ((i - 1) * wid) + j) print."
			  ].
	       stdout nl.
	       ].
] 
"11x11"
!


| screen rootWin root gc propRepl w | 
    s notNil ifTrue:
	[ s close ].
    s _ Server connectToDisplay.
    root _ s root.
    screen _ root screens at: 1.
    rootWin _ screen window.

    w _ Window new init: 9437268 onServer: s.

    "w getGeometry inspect."

    w doHierarchy: [ :ch | ch id printNl.
			   ch getGeometry inspect.
			   "ch getWindowAttributes inspect."
			       ].
! 






| screen rootWin root gc propRepl | 
    s notNil ifTrue:
	[ s close ].
    s _ Server connectToDisplay.
    root _ s root.
    screen _ root screens at: 1.
    rootWin _ screen window.

    "tree _ rootWin queryTree.
    r _ tree root."
    rootWin doHierarchy:
	[ :w | propRepl _ (w getProperty: (Atom prop: #WmName on: s)
		    type: #AnyPropertyType
		    longOffset: 0
		    longLength: 32 
		    delete: false) "type getAtomName" "inspect ".
	       stdout print: w id; nextPutAll: ' ';
		   nextPutAll: propRepl value asString ; nl.
		    ].

!
    (rootWin queryTree children) do:
	[ :ch | "ch inspect "
		propRepl _ (ch getProperty: (Atom prop: #WmName on: s)
		    type: #AnyPropertyType
		    longOffset: 0
		    longLength: 32 
		    delete: false) "type getAtomName" "inspect ".
		    propRepl value asString printNl.
		    ].
