"======================================================================
|
|   A start at an X resoure parser.
|
|   $Revision: 1.4 $
|   $Date: 1995/06/06 14:56:15 $
|   $Author: sbb $
|
 ======================================================================"


"======================================================================
|
| Copyright (C) 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"

"
|     Change Log
| ============================================================================
| Author       Date       Change 
| sbb	     20 Sep 94	  Incorporated Joerg Rade's changes.
|
| sbb	     28 Aug 94	  Added header stuff.
|
"
Object subclass: #Res
       instanceVariableNames: 'stream'
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
!

!Res class methodsFor: 'instance creation'!

on: aStream
    ^self new init: aStream

! !


!Res methodsFor: 'accessing'!

atEnd
    ^stream atEnd or: [ (stream peek == (Character value: 0))
			    ifTrue: [ stream next.
				      true ] 
			    ifFalse: [ false ] ]
!

nextLine
    | ch line |
    line _ WriteStream on: (String new: 50).
    [ 
      stream atEnd or: 
	  [ ch _ stream next.
	    (ch == Character nl) | (ch == (Character value: 0)) ]
	  ] whileFalse:
	      [ line nextPut: ch ].
    ^line contents
!

parseLine: line
    | i len keys val ch start done atom | 
    start _ i _ 1.
    len _ line size.
    keys _ WriteStream on: (Array new: 2).
    done _ false.
    [ (i <= len) & (done not)  ] whileTrue:
	[ ch _ line at: i.
	  ((ch == $*) | (ch == $.)) 
	      ifTrue: [ (start ~= i) ifTrue:
			    [ atom _ (line copyFrom: start to: i - 1) asSymbol.
			      keys nextPut: atom ].
			keys nextPut: ch.
			start _ i + 1.
			      
			].
	  (ch == $:) ifTrue:
	      [ atom _ (line copyFrom: start to: i - 1) asSymbol.
		keys nextPut: atom.
		done _ true ].
	  "Otherwise, accumulate name "
	  i _ i + 1
	].
    
    [ (i <= len) and: [ (line at: i) isSeparator ] ] whileTrue: 
	[ i _ i + 1 ].
    val _ line copyFrom: i to: len.
    keys contents printNl.
    val printNl.
! !



!Res methodsFor: 'private'!

init: aStream
    stream _ aStream
! !



Smalltalk at: #s put: nil!

| f scr root rootWin w screen gc r tree cur pix atom cmap 
  yellowPixel bits str pgc fi w2 ba vis prop rs |
    s notNil ifTrue: [s close].
    "s _ Server connectTo: '' display: 0."
    s _ Server connectToDisplay.
    root _ s root.
    screen _ root screens at: 1.
    rootWin _ screen window.

    prop _ (rootWin getProperty: (Atom prop: #ResourceManager on: s)
	     type: (Atom prop: #String on: s)
	longOffset: 0 longLength: 99999 delete: false).
    "rs _ Res on: (ReadStream on: prop value asString)."
    rs _ Res on: (FileStream open: (Smalltalk getenv: 'HOME'), '/.Xdefaults'
			     mode: 'r').
    [ rs atEnd ] whileFalse: 
	[ rs parseLine: (rs nextLine) 
	      ].

!
