Smalltalk at: #DebugPrinting put: true!

!Object methodsFor: 'debugging'!

bugOut: aString
    DebugPrinting 
	ifTrue: [ aString print. self printNl ]
!

hexBug: aString
    DebugPrinting 
	ifTrue: [ aString print. self printOn: stdout base: 16. stdout nl ]
!!


!BlockContext methodsFor: 'fun hacking'!

ifDebug
    DebugPrinting ifTrue: [ self value ]
!!


!String methodsFor: 'converting'!

asByteArray
    | bytes i |
    bytes _ ByteArray new: self size.
    i _ 1.
    self do: [ :char | bytes at: i put: (char asciiValue).
		       i _ i + 1 ].
    ^bytes
!!



!GC methodsFor: 'example class'!


drawExampleImage: button
    self polyText8: (Array with: (TextItem onString: 'Welcome to ')
			 with: (TextItem onString: Version ))
       x: 50 y: 30.

    self polyLine: 20@20 to: 40@40 coordMode: #Origin.
    self polyLine: 40@20 to: 20@40 coordMode: #Origin.
	
    self polyRectangle: (Array with: (10 @ 10 corner: (400 - 20) @ (200 - 20))). 
    self drawExampleButton: button.
"    self polyFillRectangle: (Array with:  (10 @ 10 corner: 50 @ 50))."
    self polyArc: (Array with: (Arc new: 10 @ 10 size: 40 @ 40 angles: (90*64) @ (180*64))).
    self polyArc: (Array with: (Arc new: 10 @ 50 size: 40 @ 40 angles: (270*64) @ (180*64)))
!


drawExampleButton: button
    | textStart |
    self polyRectangle: (Array with: button). 
    textStart _ button leftCenter.
    self polyText8: (Array with: (TextItem onString: 'Click here to exit'))
	 x: textStart x + 10 y: textStart y
!!




!Display methodsFor: 'anonymous protocol requests'!

listFonts: aPattern maxNames: anInteger
    | packet numStrs strs n str |
    packet _ XPacket command: 49.
    socket bytes: (packet word: anInteger; word: aPattern size;
			       bytes: aPattern asByteArray; done).
    socket getReply
	ifFalse: [ ^self ].
    
    numStrs _ socket word.
    socket skipBytes: 22.	"there should be a better way"
    strs _ Array new: numStrs.
    1 to: numStrs do:
	[ :i | n _ socket byte.
	       str _ (socket getUnpaddedString: n).
	       strs at: i put: str ].
    ^strs
!!

!Dictionary methodsFor: 'printing'!

printOn: aStream
    self associationsDo: 
	[ :assoc | assoc key printOn: aStream.
		   ' -> ' printOn: aStream.
		   assoc value printOn: aStream.
		   aStream nl ]
!!



| d s result id title win gc event button tracking pen |

    id _ 0.

    "Create the initial display connection"
    d _ Display host: '' display: 0.
    d isNil ifTrue: [ ^self error: 'Failed to create display' ].

    " Create the root window from the initial display connection"
    RootWindow _ Window new: d id: RootWindowID.

    "An example of how to work listFonts:"
"    (d listFonts: '*adobe*normal*' maxNames: 9999) printNl."

    s _ d socket.


    "Create a window that is as deep as the parent deep"
    win _ RootWindow createWindow: 0 "depth"
		     x: 100 y: 100
		     width: 400 height: 200
		     borderWidth: 5 class: #CopyFromParent
		     visual: #CopyFromParent
		     attrs: [ :pack | pack backgroundPixel: WhitePixel;
					  borderPixel: BlackPixel;
					   eventMask: #(Exposure ButtonPress ButtonRelease)
					  ].


    gc _ win createGC: [ :pack | pack foreground: BlackPixel;
				      background: WhitePixel;
				      "lineWidth: 10;"
				      lineStyle: #Solid ].

    " Set the name of the window "
    win changeProperty: #WmName
	type: #String mode: #Replace format: 8 data: Version asByteArray.

    " Display the window "
    win mapWindow.

    " Get the exposure event "
    s getPacket.

    'about to display packet' printNl.
    "win getGeometry print."

    " Draw a nice picture "
	[ :i | pen _ Pen new: gc.
	       pen goto: (150+i)@(100+i).
	       pen down.

	       " Draw a dragon curve "
	       pen dragon: 6.] value: 0.

    button _ 230 @ 130 extent: 130 @ 40.

    " create the rest of the image, including the button "
    gc drawExampleImage: button.

    " Wait until a button press event "
    [ event _ s getPacket.
      event class == ButtonPressEvent
	  ifTrue: [ (button containsPoint: event eventX @ event eventY) ]
	  ] whileFalse.

    " Tidy up "
    win destroyWindow.

!

Smalltalk quitPrimitive!

